// 3.1     Article.

/*
       RSS . 
    .
         . 
          .

 :
       .      .
*/


//  :
function RSSfeed(title,scanPeriod,url,weight) {
    this.title=title; 
    this.scanPeriod=scanPeriod; 
    this.url=url; 
    this.weight=weight;
    this.status="";
    this.lastRescan=-Infinity;
}

var feeds = new Array();  //   
var articles = new Object();  //  
var infoPeacesByTitle = new Object();  
var infoPeacesByDescription = new Object();  
var feedRescanTimers = new Array(); 


function immediateFeedScan() {   
    for (var i = 0; i < feeds.length; i++) if (feeds[i]) {
        updateFeed(i);
    }
}

function addFeed(feed) {
    feed.id=pack(feeds, feed);

    if (feedPropsWindow != null) {
        feedPropsWindow.addFeedString(feed);
    }

    pack(
        feedRescanTimers,
        window.setInterval('feedRescanTimer(feeds[' + feed.id  + '])', feed.scanPeriod*1000)
    );
    feedRescanTimer(feed);
}

function updateFeed(id) {
    window.clearInterval( feedRescanTimers[id] );

    feedRescanTimers[id] = 
        window.setInterval('feedRescanTimer(feeds[' + id  + '])', feeds[id].scanPeriod*1000);
    feedRescanTimer(feeds[id]);
}


function feedRescanTimer(feed) {
    scanFeed(feed);

    if(feedPropsWindow) if(feedPropsWindow.document) if(feedPropsWindow.document.getElementById('nextRescanSeconds' + feed.id)) {
       feedPropsWindow.document.getElementById('nextRescanSeconds' + feed.id).innerHTML = feed.scanPeriod;
    }
}


function deleteFeed(id) {
    feeds[id] = undefined;
    window.clearInterval( feedRescanTimers[id] );
    feedRescanTimers[id] = undefined;

    if (feedPropsWindow != null) {
        feedPropsWindow.addAllFeedStrings();
    }
}



//  :
function scanFeed(feed) {
    feed.status="Rescanning";
    if (feedPropsWindow) {
        feedPropsWindow.updateStatus(feed.id);
    }

    var xmlHttp = XmlHttp.create();
    var rssSrc = feed.url;
    var responseXML = null;
    xmlHttp.open("GET", rssSrc, true); // async
    xmlHttp.onreadystatechange = function () {
        if (xmlHttp.readyState == 4) {
            var responseXML = xmlHttp.responseXML;
            error = responseXML.parseError;
            if (error.errorCode != 0) {
                feed.errorDescr = error.reason + " line:" + error.line + ", pos:"+error.linepos;
            } else if (responseXML.getElementsByTagName('channel').item(0)) {
                var channel = responseXML.getElementsByTagName('channel').item(0);
                var channelTitle = null;                    
                if (channel.getElementsByTagName('title').item(0)) if (channel.getElementsByTagName('title').item(0).firstChild) {
                    channelTitle = channel.getElementsByTagName('title').item(0).firstChild.nodeValue;
                }
                var channelLink = null;
                if (channel.getElementsByTagName('link').item(0)) if (channel.getElementsByTagName('link').item(0).firstChild) {
                    channelLink = channel.getElementsByTagName('link').item(0).firstChild.nodeValue;
                }
                var channelImageUrl = null;
                if (channel.getElementsByTagName('image').item(0)) {
                    if (channel.getElementsByTagName('image').item(0).getElementsByTagName('url').item(0)) if (channel.getElementsByTagName('image').item(0).getElementsByTagName('url').item(0).firstChild) {
                        channelImageUrl = channel.getElementsByTagName('image').item(0).getElementsByTagName('url').item(0).firstChild.nodeValue;
                    }
                }

                var numberOfNewItems = 0;
                itemsNodeList = responseXML.getElementsByTagName('item');
                for (var i = 0; i < itemsNodeList.length; i++) {
                    var itemNode = itemsNodeList.item(i);
                    var title = null;
                    if (itemNode.getElementsByTagName('title').item(0)) if (itemNode.getElementsByTagName('title').item(0).firstChild) {
                        title = itemNode.getElementsByTagName('title').item(0).firstChild.nodeValue;
                    }
                    var description = null;
                    if (itemNode.getElementsByTagName('description').item(0)) if (itemNode.getElementsByTagName('description').item(0).firstChild) {
                        description = itemNode.getElementsByTagName('description').item(0).firstChild.nodeValue;
                    }
                    var category = null;
                    if (itemNode.getElementsByTagName('category').item(0)) if (itemNode.getElementsByTagName('category').item(0).firstChild) {
                        category = itemNode.getElementsByTagName('category').item(0).firstChild.nodeValue;
                    }
                    var imageUrl = null;
                    if (itemNode.getElementsByTagName('image').item(0)) if (itemNode.getElementsByTagName('image').item(0).getElementsByTagName('url').item(0)) if (itemNode.getElementsByTagName('image').item(0).getElementsByTagName('url').item(0).firstChild) {
                        imageUrl = itemNode.getElementsByTagName('image').item(0).getElementsByTagName('url').item(0).firstChild.nodeValue;
                    }
                    var pubDate = null;
                    if (itemNode.getElementsByTagName('pubDate').item(0)) if (itemNode.getElementsByTagName('pubDate').item(0).firstChild) {
                        pubDate = itemNode.getElementsByTagName('pubDate').item(0).firstChild.nodeValue;
                    }
                    var isNew = false;
                    if (itemNode.getElementsByTagName('link').item(0)) if (itemNode.getElementsByTagName('link').item(0).firstChild) {
                        var link = itemNode.getElementsByTagName('link').item(0).firstChild.nodeValue;
                        isNew = (articles[link] == undefined);
                    } else if(title) {
                        isNew = (infoPeacesByTitle[title] == undefined);
                    } else if(description) {
                        isNew = (infoPeacesByDescription[Description] == undefined);
                    }
// else - bad item;

// Create descr
                    if (isNew) {
                        var descr = "<div style='padding: 15px; width: 18em; text-align: left; font-family: Arial. Verdana, Tahoma; font-size: 10pt'>";
                        if (channelImageUrl) {
                            descr += "<img style='float: left' src='"+ channelImageUrl +"'/>";
                        }
                        if (channelTitle) {
                            descr += "<small><small> "+ channelTitle +" </small></small>";
                        }
                        if (channelLink) {
                            descr += "<a href='"+channelLink+"'><small><small><small>("+ channelLink +")</small></small></small></a>";
                        }
                        if (channelLink || channelTitle) {
                            descr += "<br/>";
                        }
                        if (pubDate) {
                            descr += "<small>"+pubDate+"<small><br/>";
                        }
                        if (channelLink || channelTitle || pubDate) {
                            descr += "<br/>";
                        }
                        if (description) {
                            descr += "<div style='text-align: Justify;'><strong><small>Description:  </small></strong>";
                            if (imageUrl) {
                               descr += "<img style='float: right' src='"+ imageUrl +"' />";
                            }
                            descr +="<span style='font: Georgia;'>" + description + "</span></div>";
                        }
                        descr +="</div>";

                        if (link) {
                            var theitem = new Article(feed.title, title, descr, link, feed.weight);
                            articles[link] = theitem;
                        } else {
                            var theitem = new InfoPeace(feed.title, title, descr, feed.weight);
                            if (title) {
                                infoPeacesByTitle[title] = theitem;
                            } else if(description) {
                                infoPeacesByDescription[Description] = theitem;
                            }
                        }
                        waitQueue.push(theitem);
                        numberOfNewItems++;
                    }
                }
                if (numberOfNewItems!=0) {
                    waitQueue.sort(function compareWeights(a, b) {return b.weight-a.weight});
                }
                feed.status = "OK("+numberOfNewItems+"/"+itemsNodeList.length+" new)";
                feed.lastRescan = (new Date()).getTime();
                if (feedPropsWindow) {
                    feedPropsWindow.updateStatus(feed.id);
                }
            } else {
                feed.status = "Falture";
                if (feedPropsWindow) {
                    feedPropsWindow.updateStatus(feed.id);
                }
            }
        }
    };
    // call in new thread to allow ui to update
    window.setTimeout(function () {
        try {
            xmlHttp.send(null);
        } catch (e) {
            feed.status = "Request error";
            if (feedPropsWindow) {
                feedPropsWindow.updateStatus(feed.id);            
            }
        }
    }, 10);
}


// alert('t-rss loaded');