//    .
//   waitQueue         .
//       freeItems
//
//  waitQueue  -    cycle.    -   
//   .   -      .


var SCROLLAMOUNT = 1;       /*  ,      */
var SCROLLDELAY = 25; /*  ** .  */
var COMPACTIZE_AMOUNT = 7;

var ticker;   /* ,       */

var cycle=true;  /* . . .  */
var scrollPause = false;


//       .
var scrollTimerId = null;

function startScroll() {
      scrollTimerId = window.setInterval('scrollTicker()', SCROLLDELAY);
}

 
//   visibleNodes:
firstVisibleNode = null;
lastVisibleNode = null;
function pushNode(node) {
    if (lastVisibleNode) {
        lastVisibleNode.next = node;
        node.prev = lastVisibleNode;
        lastVisibleNode = node;
    } else {
        firstVisibleNode = lastVisibleNode = node;
    }
}

function shiftNode() {
    var output = firstVisibleNode;
    if (firstVisibleNode == lastVisibleNode) {
        firstVisibleNode = lastVisibleNode = null;
    } else {
        firstVisibleNode = firstVisibleNode.next;
        firstVisibleNode.prev = null;
    }
    return output;
}


//   :
function scrollTicker() {
    if (firstVisibleNode) {
        var moveAmount = scrollPause ? 0
                                     : SCROLLAMOUNT;

        for(node = firstVisibleNode; node != null; node = node.next) {
            node.style.pixelLeft -= moveAmount;
            if (node.compactize) {
                var distance = (node.prev) ? node.style.pixelLeft - node.prev.offsetLeft - node.prev.offsetWidth
                                           : Math.max(node.offsetLeft, 0);
                var moveBy = Math.min(distance, COMPACTIZE_AMOUNT);
                node.style.pixelLeft -= moveBy;
                moveAmount += moveBy;
            }
        } 
        if (lastVisibleNode.offsetLeft + lastVisibleNode.offsetWidth < document.body.offsetWidth) {
            if (waitQueue.length > 0) {
                var newNode = createNode( waitQueue.shift() );
                newNode.compactize = true;
                pushNode(newNode);
            } else if (cycle && freeItems.array.length > 0) {
                pushNode( 
                    createNode( freeItems.pop() )
                );
            }
        }    
        if (firstVisibleNode.offsetLeft + firstVisibleNode.offsetWidth < 0) {
            var overLeftBorderNode = shiftNode();
            removeNode(overLeftBorderNode);
            if (overLeftBorderNode.item.state == undefined) {
                   freeItems.push(overLeftBorderNode.item);
            }
        }  
    } else {
        if (waitQueue.length > 0) {
            var newNode = createNode( waitQueue.shift() );
            newNode.compactize = true;
            pushNode(newNode);
        } else if (cycle && freeItems.array.length > 0) {
            pushNode( 
                createNode( freeItems.pop() )
            );
        }
    }
}

//     :

function collapseNode(node) {
    if (node.prev) {
        node.prev.next = node.next;
    } else {
        firstVisibleNode = node.next;
    } 

    if (node.next) {
        node.next.prev = node.prev;
    } else {
        lastVisibleNode = node.prev;
     }

    removeNode(node);
    if(node.next) node.next.compactize = true;
    scrollPause = false;
}


//alert('t-scroll loaded');
